#pragma config(Sensor, port3,  Color,          sensorVexIQ_Color12Color)
#pragma config(Sensor, port4,  Distance,       sensorVexIQ_Distance)
#pragma config(Sensor, port5,  ColorDisplay,   sensorVexIQ_LED)
#pragma config(Sensor, port9,  StartAgain,     sensorVexIQ_LED)
#pragma config(Motor,  motor1,          Belt,          tmotorVexIQ, PIDControl, encoder)
#pragma config(Motor,  motor2,          ArmRotate,     tmotorVexIQ, PIDControl, encoder)
#pragma config(Motor,  motor7,          Gripper,       tmotorVexIQ, PIDControl, encoder)
#pragma config(Motor,  motor8,          ArmLift,       tmotorVexIQ, PIDControl, encoder)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

void InitMotors(void)
{
  setMotorBrakeMode(ArmLift, motorCoast);
  setMotorCurrentLimit(ArmLift, 100);
  setMotorSpeed(ArmLift, 40);
  do {sleep(100); while(!getMotorZeroVelocity(ArmLift)) sleep(1);} while(false);
  setMotorSpeed(ArmLift, 0);
  wait1Msec(200);
  resetMotorEncoder(ArmLift);
  setMotorBrakeMode(ArmLift, motorHold);

  setMotorBrakeMode(ArmRotate, motorCoast);
  setMotorCurrentLimit(ArmRotate, 60);
  setMotorSpeed(ArmRotate, 40);
  do {sleep(100); while(!getMotorZeroVelocity(ArmRotate)) sleep(1);} while(false);
  setMotorSpeed(ArmRotate, 0);
  wait1Msec(200);
  resetMotorEncoder(ArmRotate);
  setMotorBrakeMode(ArmRotate, motorHold);

  setMotorBrakeMode(Gripper, motorCoast);
  setMotorCurrentLimit(Gripper, 100);
  setMotorSpeed(Gripper, 40);
  do {sleep(100); while(!getMotorZeroVelocity(Gripper)) sleep(1);} while(false);
  setMotorSpeed(Gripper, 0);
  wait1Msec(200);
  resetMotorEncoder(Gripper);
  setMotorBrakeMode(Gripper, motorHold);

  resetMotorEncoder(Belt);
}
void ResetArm(void)
{
  setMotorTarget(Gripper, -300, 40);
  waitUntilMotorStop(Gripper);
  setMotorTarget(ArmLift, -150, 40);
  setMotorTarget(ArmRotate, 0, 100);
  waitUntilMotorStop(ArmLift);
  waitUntilMotorStop(ArmRotate);
}

void MoveArm(int ArmAngle)
{
  // Pick Brick
  setMotorTarget(Gripper, -200, 40);
  waitUntilMotorStop(Gripper);
  // Raise Arm
  setMotorTarget(ArmLift, -80, 40);
  waitUntilMotorStop(ArmLift);
  // Turn Arm
  setMotorTarget(ArmRotate, ArmAngle, 100);
  waitUntilMotorStop(ArmRotate);
  // Lower Arm
  setMotorTarget(ArmLift, -150, 40);
  waitUntilMotorStop(ArmLift);
  // Drop Brick
  setMotorTarget(Gripper, -300, 40);
  waitUntilMotorStop(Gripper);
  // Raise Arm
  setMotorTarget(ArmLift, -80, 40);
  waitUntilMotorStop(ArmLift);
}

// Arm rotate range: 0 (on belt) to -600
// Arm lift range: 0 (fully up) to -150 (on belt)
// Gripper range: 0 (fully close) to -300 (fully open)


task main()
{

  int currentHueValue, detectedColor;
  int ArmAngle;
  InitMotors();
  setColorMode(Color,colorTypeRGB_Hue_Reflected);
  while(true)
  {
      ResetArm();
      setMotorSpeed(Belt, 30);
      do
      {
        while (getDistanceStrongest(Distance)>40)
        {
          wait1Msec(20);
          if(getMotorEncoder(Belt)>1100)
          {
            setMotorSpeed(Belt, 0);
            setTouchLEDBlinkTime(StartAgain, 10, 10);
            setTouchLEDColor(StartAgain, colorGreen);
            while(getTouchLEDValue(StartAgain)==0)wait1Msec(100);
            setTouchLEDColor(StartAgain, colorNone);
            setMotorSpeed(Belt, 30);
            resetMotorEncoder(Belt);
          }
        }
      } while (getDistanceStrongest(Distance)>40);

      resetMotorEncoder(Belt);
      while (getMotorEncoder(Belt)<315) wait1Msec(10);
      currentHueValue = getColorValue(Color);
      if((currentHueValue <= 15)||(currentHueValue) > 250)
      {
        detectedColor = colorRed;
        ArmAngle = -215;
      }
      else if((currentHueValue > 15) && (currentHueValue <= 40))
      {
        detectedColor = colorOrange;
        ArmAngle = -275;
      }
      else if((currentHueValue > 40) && (currentHueValue <= 90))
      {
        detectedColor = colorYellow;
        ArmAngle = -365;
      }
      else if((currentHueValue > 90) && (currentHueValue <= 130))
      {
        detectedColor = colorGreen;
        ArmAngle = -480;
      }
      else if((currentHueValue > 131) && (currentHueValue <= 219))
      {
        detectedColor = colorBlue;
        ArmAngle = -550;
      }
      setTouchLEDColor(ColorDisplay, detectedColor);
      while (getMotorEncoder(Belt)<560) wait1Msec(10);
      setMotorSpeed(Belt, 0);
      MoveArm(ArmAngle);
      setTouchLEDColor(ColorDisplay, colorNone);
      wait1Msec(100);
  }
}

